;
; http://oric.free.fr/programming.html#disc
;

#define location_loader               $fb00

/* Location of the first zero page address used during the loading */
#define loader_zp_start               $80 

/* Location of the 256 bytes buffer used to load the sectors */
#define loader_sector_buffer          $200 

; Location of the loader on the disk (track number)
#define loader_track_position         0
; Location of the loader on the disk (sector number)
#define loader_sector_position        4

#define wait_status_floppy            30

#define FINAL_ADDRESS                 $0400
#define OPCODE_RTS                    $60

; MICRODISC
#ifdef MICRODISC_LOADER
#define FDC_command_register          $0310
#define FDC_status_register           $0310
#define FDC_track_register            $0311
#define FDC_sector_register           $0312
#define FDC_data                      $0313
#define FDC_flags                     $0314
#define FDC_drq                       $0318

#define FDC_Offset                    $00

#define CMD_Restore                   $00
#define CMD_ForceInterrupt            $d0

#define CMD_WriteSector               $a0
#define CMD_ReadSector                $80
#define CMD_Seek                      $1f
#define FDC_Flag_DiscSide             %00010000
#endif

; JASMIN
#ifdef JASMIN_LOADER
#define FDC_command_register          $03f4
#define FDC_status_register           $03f4
#define FDC_track_register            $03f5
#define FDC_sector_register           $03f6
#define FDC_data                      $03f7
#define FDC_flags                     $03f8
#define FDC_drq                       $03fc

#define FDC_ovl_control               $3fa
#define FDC_rom_control               $3fb

#define FDC_Offset                    $e4

#define CMD_Restore                   $00
#define CMD_ForceInterrupt            $d0

#define CMD_WriteSector               $ac
#define CMD_ReadSector                $8c
#define CMD_Seek                      $1f
#define FDC_Flag_DiscSide             %00000001
#endif


#define fdc_flags_mask                %10000100

#define fdc_base                      $310
#define fdc_command_register          fdc_base+0
#define fdc_status_register           fdc_base+0
#define fdc_track_register            fdc_base+1
#define fdc_sector_register           fdc_base+2
#define fdc_data                      fdc_base+3
#define fdc_flags                     fdc_base+4
#define fdc_drq                       fdc_base+8

#define location_fdc_offset           location_loader+3
#define location_cmd_writesector      location_loader+4
#define location_cmd_readsector       location_loader+5
#define location_cmd_seek             location_loader+6
#define location_cmd_forceinterrupt   location_loader+7
#define location_fdc_flag_discside    location_loader+8

/***************************************************************************************************************************************
; $0314 / $03f8
;
;   |xxxxxxxx| Write
;    ||||||||
;    ||||||||_____bit 0: enable FDC INTRQ to appear on read location $0314 and to drive cpu IRQ
;    |||||||_____ bit 1: ROMDIS (active low). When 0, internal Basic rom is disabled.
;    ||||||______ bit 2: along with bit 3, selects the data separator clock divisor (1: double density, 0: single density)
;    |||||_______ bit 3: double density enable (0: enable double density, 1: disble DD, i.e. single density)
;    ||||________ bit 4: side select
;    |||_________ bit 5: drive select (0 to 3)
;    ||__________ bit 6: drive select (0 to 3)
;    |___________ bit 7: Eprom select (active low)
;
;   |x.......| Read
;    |____________ bit 7: INTRQ state (only if bit 0 above has been set to 1) in negative logic so it`s 0 if FDC requests an Interrupt.
;
;
; $0318 / $03fc
;
;   bit 7: DRQ state (active low)
***************************************************************************************************************************************/
