setloadaddress  = $fff1
loadfile        = $fff4
savefile        = $fff7

indenable  
        .byt 0
indchar
        .byt 0

; void IndSet(char enable)
_IndSet
.(
        sty tmp0
        ldy #0
        lda (sp),y
        sta indenable
        ldy tmp0
        rts
.)

; void IndDefine(char mode, char offset, char* ptr)
_IndDefine
.(
        sty tmp0
        ldy #0
        sty dst
        lda (sp),y
        beq text_mode
hires_mode
        lda #$9c
        sta dst+1
        bne cont
text_mode
        lda #$b9
        sta dst+1

cont
        ldy #2
        lda (sp),y
        pha
        clc
        adc #$20
        sta indchar
        
        pla
        asl
        asl
        asl

        clc
        adc dst
        sta dst
        lda dst+1
        adc #0
        sta dst+1
        
        ldy #4
        lda (sp),y
        sta src
        iny
        lda (sp),y
        sta src+1
    
        ldx #0
loop
src     = *+1
        lda $cafe,x        
dst     = *+1
        sta $cafe,x
        inx
        cpx #(4*8)
        bcc loop

        ldy tmp0
        rts
.)

indshow
.(
        ldx indenable
        bne show
        rts
show
        ldx #$07
        stx $bb80+40*26+36
        stx $bb80+40*27+36
        ldx #$09
        stx $bb80+40*26+37
        stx $bb80+40*27+37
        ldx indchar
        stx $bb80+40*26+38
        inx
        stx $bb80+40*26+39
        inx
        stx $bb80+40*27+38
        inx
        stx $bb80+40*27+39
        rts
.)

indhide
.(
        ldx #$00
        stx $bb80+40*26+36
        stx $bb80+40*27+36
        rts
.)

; void LoadFile(int entryindex);
_LoadFile
.(
        sty tmp0
        jsr indshow

        ldy #0
        lda (sp),y
        tax
        jsr loadfile

        jsr indhide
        ldy tmp0
        rts
.)

; void LoadFileAt(int entryindex, unsigned char* addr);
_LoadFileAt
.(
        sty tmp0
        jsr indshow

        ldy #0
        lda (sp),y
        tax         ; LoaderApiEntryIndex

        ldy #2
        lda (sp),y  ; LoaderApiAddressLow
        sta tmp1

        iny
        lda (sp),y  ; LoaderApiAddressHigh
        tay
        lda tmp1
        jsr setloadaddress

        ldy #0
        lda (sp),y
        tax
        jsr loadfile

        jsr indhide
        ldy tmp0
        rts
.)

; void LoadFileRun(int entryindex, unsigned char* addr);
_LoadFileRun
.(
        ; clear the stack

        sei
        ldx #$ff
        txs
        cli

        ldy #0
        lda (sp),y
        tax         ; LoaderApiEntryIndex

        ldy #2
        lda (sp),y  ; LoaderApiAddressLow
        sta tmp0

        iny
        lda (sp),y  ; LoaderApiAddressHigh
        pha
        tay
        lda tmp0
        pha
        jsr setloadaddress

        ldy #0
        lda (sp),y
        tax

        ; Return to entry point
        jmp loadfile
.)

; void SaveFile(int entryindex);
_SaveFile
.(
        sty tmp0
        jsr indshow

        ldy #0
        lda (sp),y
        tax
        jsr savefile

        jsr indhide
        ldy tmp0
        rts
.)

; void SaveFileAt(int entryindex, unsigned char* addr);
_SaveFileAt
.(
        sty tmp0
        jsr indshow

        ldy #0
        lda (sp),y
        tax         ; SaveerApiEntryIndex

        ldy #2
        lda (sp),y  ; SaveerApiAddressLow
        sta tmp1

        iny
        lda (sp),y  ; SaveerApiAddressHigh
        tay
        lda tmp1
        jsr setloadaddress

        ldy #0
        lda (sp),y
        tax
        jsr savefile

        jsr indhide
        ldy tmp0
        rts
.)
